local __FILE__=tostring(debugstack(1,2,0):match("(.*):1:")) -- Always check line number in regexp and file, must be 1
--[===[@debug@
print('Loaded',__FILE__)
--@end-debug@]===]
local function pp(...) print(GetTime(),"|cff009900",__FILE__:sub(-15),strjoin(",",tostringall(...)),"|r") end
--*TYPE module
--*CONFIG noswitch=false,profile=true,enhancedProfile=true
--*MIXINS "AceHook-3.0","AceEvent-3.0","AceTimer-3.0","AceSerializer-3.0","AceConsole-3.0"
--*MINOR 35
-- Auto Generated
local me,ns=...
if ns.die then return end
local addon=ns --#Addon (to keep eclipse happy)
ns=nil
local module=addon:NewSubModule('Matchmaker',"AceHook-3.0","AceEvent-3.0","AceTimer-3.0","AceSerializer-3.0","AceConsole-3.0")  --#Module
function addon:GetMatchmakerModule() return module end
-- Template
local G=C_Garrison
local _
local AceGUI=LibStub("AceGUI-3.0")
local C=addon:GetColorTable()
local L=addon:GetLocale()
local new=addon:Wrap("NewTable")
local del=addon:Wrap("DelTable")
local kpairs=addon:Wrap("Kpairs")
local empty=addon:Wrap("Empty")

local todefault=addon:Wrap("todefault")

local tonumber=tonumber
local type=type
local OHF=OrderHallMissionFrame
local OHFMissionTab=OrderHallMissionFrame.MissionTab --Container for mission list and single mission
local OHFMissions=OrderHallMissionFrame.MissionTab.MissionList -- same as OrderHallMissionFrameMissions Call Update on this to refresh Mission Listing
local OHFFollowerTab=OrderHallMissionFrame.FollowerTab -- Contains model view
local OHFFollowerList=OrderHallMissionFrame.FollowerList -- Contains follower list (visible in both follower and mission mode)
local OHFFollowers=OrderHallMissionFrameFollowers -- Contains scroll list
local OHFMissionPage=OrderHallMissionFrame.MissionTab.MissionPage -- Contains mission description and party setup 
local OHFMapTab=OrderHallMissionFrame.MapTab -- Contains quest map
local OHFCompleteDialog=OrderHallMissionFrameMissions.CompleteDialog
local OHFMissionScroll=OrderHallMissionFrameMissionsListScrollFrame
local OHFMissionScrollChild=OrderHallMissionFrameMissionsListScrollFrameScrollChild
local followerType=LE_FOLLOWER_TYPE_GARRISON_7_0
local garrisonType=LE_GARRISON_TYPE_7_0
local FAKE_FOLLOWERID="0x0000000000000000"
local MAX_LEVEL=110

local ShowTT=OrderHallCommanderMixin.ShowTT
local HideTT=OrderHallCommanderMixin.HideTT

local dprint=print
local ddump
--[===[@debug@
LoadAddOn("Blizzard_DebugTools")
ddump=DevTools_Dump
LoadAddOn("LibDebug")

if LibDebug then LibDebug() dprint=print end
local safeG=addon.safeG

--@end-debug@]===]
--@non-debug@
dprint=function() end
ddump=function() end
local print=function() end
--@end-non-debug@
local LE_FOLLOWER_TYPE_GARRISON_7_0=LE_FOLLOWER_TYPE_GARRISON_7_0
local LE_GARRISON_TYPE_7_0=LE_GARRISON_TYPE_7_0
local GARRISON_FOLLOWER_COMBAT_ALLY=GARRISON_FOLLOWER_COMBAT_ALLY
local GARRISON_FOLLOWER_ON_MISSION=GARRISON_FOLLOWER_ON_MISSION
local GARRISON_FOLLOWER_INACTIVE=GARRISON_FOLLOWER_INACTIVE
local ViragDevTool_AddData=_G.ViragDevTool_AddData
if not ViragDevTool_AddData then ViragDevTool_AddData=function() end end
local KEY_BUTTON1 = "\124TInterface\\TutorialFrame\\UI-Tutorial-Frame:12:12:0:0:512:512:10:65:228:283\124t" -- left mouse button
local KEY_BUTTON2 = "\124TInterface\\TutorialFrame\\UI-Tutorial-Frame:12:12:0:0:512:512:10:65:330:385\124t" -- right mouse button
local CTRL_KEY_TEXT,SHIFT_KEY_TEXT=CTRL_KEY_TEXT,SHIFT_KEY_TEXT


-- End Template - DO NOT MODIFY ANYTHING BEFORE THIS LINE
--*BEGIN
addon.lastChange=GetTime()
local matchtimer={time=0,count=0}
local lethalMechanicEffectID = 437;
local cursedMechanicEffectID = 471;
local slowingMechanicEffectID = 428;
local disorientingMechanicEffectID = 472;
local debugMission=0
local function parse(default,rc,...)
	if rc then
		return ...
	else
	--[===[@debug@
		error(message,2)
	--@end-debug@]===]
		return default
	end
end

local meta={
__index = function(t,key)
	return function(...) return parse(nil,pcall(C_Garrison[key],...)) end end
}
--upvalues
local assert,ipairs,pairs,wipe,GetFramesRegisteredForEvent=assert,ipairs,pairs,wipe,GetFramesRegisteredForEvent
local select,tinsert,format,pcall,setmetatable,coroutine=select,tinsert,format,pcall,setmetatable,coroutine
local tostringall,strsplit,strjoin=tostringall,strsplit,strjoin
local followerType=LE_FOLLOWER_TYPE_GARRISON_7_0
local emptyTable=setmetatable({},{__newindex=function() end})
local holdEvents
local releaseEvents
local events={stacklevel=0,frames={}} --#events
function events.hold() --#eventsholdEvents
	if events.stacklevel==0 then
		events.frames={GetFramesRegisteredForEvent('GARRISON_FOLLOWER_LIST_UPDATE')}
		for i=1,#events.frames do
			events.frames[i]:UnregisterEvent("GARRISON_FOLLOWER_LIST_UPDATE")
		end
	end
	events.stacklevel=events.stacklevel+1
end
function events.release()
	events.stacklevel=events.stacklevel-1
	assert(events.stacklevel>=0)
	if (events.stacklevel==0) then
		for i=1,#events.frames do
			events.frames[i]:RegisterEvent("GARRISON_FOLLOWER_LIST_UPDATE")
		end
		events.frames=nil
	end
end
holdEvents=events.hold
releaseEvents=events.release
local maxtime=3600*24*7
-- Candidate management
local CandidateManager={perc=0,chance=0} --#CandidateManager
local CandidateMeta={__index=CandidateManager}
local emptyCandidate=setmetatable({},CandidateMeta)
local inProgressCandidate=setmetatable({},CandidateMeta)
function CandidateManager:IterateFollowers()
	return ipairs(self)
end
function CandidateManager:Follower(index)
	return self[index]
end
local busyCache={}
function addon:BusyFor(candidate)
	if not candidate then wipe(busyCache) return end
	local busyUntil=0
	for _,followerID in candidate:IterateFollowers() do
		if not busyCache[followerID] then
			busyCache[followerID]=G.GetFollowerMissionTimeLeftSeconds(followerID) or 0
		end
		if busyCache[followerID]>busyUntil then
			busyUntil=busyCache[followerID]
		end
	end
	return busyUntil
end
function addon:TroopsWillDieAnyway(candidate)
	print("willdie")
	for i=1,#candidate do
		if candidate['f' .. i] >= "T" then
			local followerID=candidate[i]
			print("willdie?",self:GetFollowerName(followerID),self:GetFollowerData(followerID,'durability',3))
			if self:GetFollowerData(followerID,'durability',3)>1 then
				return false
			end
		end
	end
	return true
end

-- Party management
local partyManager={} --#PartyManager
local missionParties={}
local partiesPool=CreateObjectPool(
	function(self) return setmetatable({},{__index=partyManager}) end,
	function(self,obj)
		local c=obj.candidates
		local ci=obj.candidatesIndex
		if ci then wipe(ci) else ci ={} end
		if c then wipe(c) else c={} end
		wipe(obj)
		obj.candidates=c
		obj.candidatesIndex=ci
	end

)

--	addon:RegisterForMenu("mission","SAVETROOPS","SPARE","MAKEITQUICK","MAXIMIZEXP")
function partyManager:Fail(reason,...)
	self.current.reason=strjoin(' ',tostringall(reason,...))
	return false,reason
end

function partyManager:SatisfyCondition(candidate,index)
	local missionID=self.missionID
	if addon:IsBanned(index,missionID) then
		return self:Fail("Slot banned")
	end	
	if type(candidate) ~= "table" then return self:Fail("NOTABLE") end
	local followerID=candidate[index]
	if not followerID then return self:Fail("No follower id for party slot",index) end
	local fType,classSpec,value,slot=strsplit('|',candidate['f'..index])
	if fType=="T" then
		if self.noTroops then return self:Fail("NOTROOPS") end
		if candidate.hasKillTroopsEffect and self.dontKillTroops then return self:Fail("WOULDKILLTROOPS") end
		local durability
		if self.saveTroops and candidate.hasKillTroopsEffect then durability = 1 end
		if self.dontKillTroops then durability= -2 end
		followerID=addon:GetTroop(tonumber(classSpec),slot or 1,missionID,durability,self.ignoreBusy)
		if followerID then candidate[index]=followerID return true,'OK' else return false,"NOAVAILABLETROOPS" end
	else
		local reserved=addon:IsReserved(followerID)
		if reserved then
			-- Always increment because, when reserved is not equal missionID we refuse the whole party
			candidate.reservedChampions=candidate.reservedChampions +1 
			return reserved==missionID
		end
		self.lastChecked=followerID
	end
	local status=G.GetFollowerStatus(followerID)
	if status then
		if addon:GetBoolean("USEALLY") and status==GARRISON_FOLLOWER_COMBAT_ALLY then
			return true
		end
		if not addon:GetBoolean('IGNOREBUSY') and status==GARRISON_FOLLOWER_ON_MISSION then
			return true
		end
		if not addon:GetBoolean('IGNOREINACTIVE') and status==GARRISON_FOLLOWER_INACTIVE then
			return true
		end
		return self:Fail("BUSY",status,G.GetFollowerName(followerID))
	end
	return true,'OK'
end
function partyManager:IterateIndex()
	--self:GenerateIndex()
	return ipairs(self.candidatesIndex)
end
local function describe(...)
	local s=''
	for i=1,select('#',...) do
		local f=addon:GetFollowerData(select(i,...))
		if f then
			if f.IsTroop then
				s=s .. tostring(f.followerID)
			else
				s=s .. tostring(f.name and f.name or f.followerID)
			end
			s=s .. ' '
		end
	end
	return s
end
function partyManager:CheckCaps(index)
	local candidate=self.candidates[self.candidatesIndex[index]]
	local chance=candidate.perc
	if chance <= self.capChance then -- Cap requisite satisfied
		if chance >= self.bonusChance then -- beats bonusChance, we take this one
			return candidate.key
		else
			self.capChance=100 -- We failed achieving bonus, so now we cap at 100
			if chance >=self.baseChance and chance <=self.capChance then
				return candidate.key
			elseif chance<self.baseChance then
				-- we are too low, so we need to go back in the chain and find someting better than baseChance even if over cap
				for k=index-1,1,-1 do
					local candidate=self.candidates[self.candidatesIndex[k]]
					if candidate and candidate.good and (self.maximizeXP or candidate.champions <= self.maxChampions) and candidate.perc >= self.baseChance then
						return candidate.key
					end
				end
				return candidate.key							
			end
		end    
	end
end
function partyManager:CheckParty(candidate)
	candidate.good=false
	local key,chance=candidate.key,candidate.perc
	local missionID=self.missionID
	if not self.elite and chance < self.minChance then return end
	if type(self.numFollowers) ~= "number" then
		self.numFollowers=addon:GetMissionData(missionID,"numfollowers",3)
	end
	if addon:GetBoolean("SPARE") and candidate.cost > candidate.baseCost then return self:Fail("SPARE",addon:GetBoolean("SPARE"),candidate.cost , candidate.baseCost) end
	if addon:GetBoolean("MAKEITVERYQUICK") and not candidate.timeImproved then return self:Fail("VERYQUICK") end
	if addon:GetBoolean("MAKEITQUICK") and candidate.hasMissionTimeNegativeEffect then return self:Fail("QUICK") end
	if addon:GetBoolean("BONUS") and candidate.hasBonusLootNegativeEffect then return self:Fail("BONUS") end			
	local mandatoryfound=0
	for j=1,#candidate do
		if not self:SatisfyCondition(candidate,j) then return end
	end
	for _,mandatory in ipairs(self.mandatoryFollowers) do
		if not tContains(candidate,mandatory) then
			return self:Fail("NOMANDATORY")
		end
	end
	self.candidates[key].good=true -- This party is good, we now check caps
	return key
end
function partyManager:GetChanceForKey(key)
	local candidate=self.candidates[key]
	return candidate and candidate.perc or 0
end
function partyManager:GetSelectedParty(key,dbg)
	-- When we receive a key we MUST return the selected party, no question asked
	if type(key)=="string" and self.candidates[key] then
		return self.candidates[key],key
	end
	if #self.candidatesIndex ==0 then return self.candidates["EMPTY"],"EMPTY" end
	local missionID=self.missionID
	local xpgainers=0
	self.maximizeXP=addon:GetBoolean("MAXIMIZEXP")
	self.minChance=addon:GetNumber("MINCHANCE")
	self.baseChance=addon:GetNumber("BASECHANCE")
	self.bonusChance=self.elite and 100 or addon:GetNumber("BONUSCHANCE")
	self.ignoreBusy=addon:GetBoolean("IGNOREBUSY")
	self.noTroops=addon:GetBoolean("NOTROOPS")
	self.saveTroops=addon:GetBoolean("SAVETROOPS")
	self.dontKillTroops=addon:GetBoolean("NEVERKILLTROOPS")
	self.capChance=self.elite and 100 or 200
	self.maxXp=0
	self.bestkey,self.xpkey,self.absolutebestkey,self.lastkey,self.uncappedkey=nil,nil,nil,nil,nil
	self.mandatoryFollowers=new()
	self.lastreason='GOOD'
	self.maxChampions=addon:GetNumber("MAXCHAMP")
	self.mandatoryFollowers=addon:GetReservedFollowers(missionID)
	for i=1,#self.candidatesIndex do
		local candidate=self.candidates[self.candidatesIndex[i]]
		self.current=candidate
		if candidate then
			local key = candidate.key 
			candidate.reservedChampions=0
			if self:CheckParty(candidate) then
				if self.maximizeXP and candidate.totalXP >self.maxXp then 
					self.maxXp=candidate.totalXP
					self.xpkey=key 
				end
				if candidate.champions > math.max(candidate.reservedChampions,self.maxChampions) then 
					self:Fail(format("TOOMANYCHAMPIONS %d over %d",candidate.champions,self.maxChampions))
				else
					if not self.uncappedkey then self.uncappedkey=key end
					if not self.absolutebestkey then self.absolutebestkey=key end
					if not self.bestkey then self.bestkey=self:CheckCaps(i) end
					self.lastkey=key
				end
			end
			if self.bestkey and not self.maximizeXP then break end
			if candidate.perc < self.minChance then candidate.reason = "UNDERMINCHANCE" break end
--[===[@debug@
			if dbg then
				print(i,candidate.key,candidate.reason)
			end
--@end-debug@			]===]
		end
	end -- for i,key in ipairs(self.candidatesIndex) do
	self.current=nil
	del(self.mandatoryFollowers,false)
	self.mandatoryFollowers=nil
	local selected
	if self.xpkey then
		selected = self.candidates[self.xpkey]
	elseif self.bestkey then
		selected = self.candidates[self.bestkey]
	elseif not addon:GetBoolean("IGNOREBUSY") and self.absolutebestkey then
		selected = self.candidates[self.absolutebestkey]
	elseif self.lastkey then
		--if self.candidates[lastkey].busyUntil <= GetTime() then
			selected = self.candidates[self.lastkey] -- should not return busy followers
		--end
	else
		selected = self.candidates["EMPTY"]
	end
	self.bestChance=selected.perc or 0
	self.bestTimeseconds=selected.timeseconds or 0
	self.previouskey=selected.key
	return selected,selected.key
end
function partyManager:Remove(...)
	local tbl=...
	if type(tbl)=="table" then
		for i =1,#tbl do
			local id=tbl[i]
			if type(id)=="table" then id=id.followerID end
			local rc,message=pcall(G.RemoveFollowerFromMission,self.missionID,id)
		end
	else
		for i=1,select('#',...) do
			local rc,message=pcall(G.RemoveFollowerFromMission,self.missionID,(select(i,...)))
		end
	end
end
function partyManager:GetEffects()
	local timestring,timeseconds,timeImproved,chance,buffs,missionEffects,xpBonus,materials,gold=G.GetPartyMissionInfo(self.missionID)
	if not missionEffects then missionEffects={} end
	missionEffects.timestring=timestring
	missionEffects.timeseconds=timeseconds
	missionEffects.perc=chance or 0
	missionEffects.timeImproved=timeImproved
	missionEffects.xpBonus=xpBonus
	missionEffects.materials=materials
	missionEffects.gold=gold

	local improvements=5
	if timeImproved then improvements=improvements -1 end
	if missionEffects.hasMissionTimeNegativeEffect then improvements=improvements+1 end
	missionEffects.baseCost,missionEffects.cost=G.GetMissionCost(self.missionID)
	if missionEffects.baseCost and missionEffects.cost then
		if missionEffects.baseCost < missionEffects.cost then
			improvements=improvements+2
		elseif missionEffects.baseCost > missionEffects.cost then
			improvements=improvements-1
		end
	end
	if missionEffects.hasKillTroopsEffect then
		improvements=improvements+2
	end
	missionEffects.improvements=improvements
	return missionEffects

end
function partyManager:Build(...)
	local missionID=self.missionID
	self.numFollowers=self.numFollowers or G.GetMissionMaxFollowers(missionID)
	local followers=new()
	local troopcost,xpGainers,champions,troops=0,0,0,0
	local assigned=select('#',...)
	if assigned>0 then
		for i=1,self.numFollowers or 3 do
			local s=select(i,...)
			if s then
				local fType,followerID,value,slot=strsplit('|',s)
				value=tonumber(value) or 0
				if fType=='T' then
					slot=tonumber(slot) or 1
					followerID=addon:GetTroop(tonumber(followerID),slot)
					if not followerID then print(s,"not converted") end
				end
				if followerID then
					local rc,res = pcall(G.AddFollowerToMission,missionID,followerID)
					if not rc or not res then
						self:Remove(followers)
						del(followers)
						return
					end
					tinsert(followers,followerID)
					if fType=="H" then -- Champion
						champions=champions+1
						if value < addon:MAXQLEVEL() then
							xpGainers=xpGainers+1
						end
					else
						troops=troops +1
						troopcost=troopcost + value
					end
				end
			end
		end
	end
	local missionEffects=self:GetEffects()
	missionEffects.xpGainers=xpGainers
	missionEffects.totalXP=(todefault(missionEffects.bonusXP,0) + todefault(self.baseXP,0))*(missionEffects.xpGainers or 0)	
	missionEffects.champions=champions
	missionEffects.troops=troops
	missionEffects.troopcost=troopcost
	self.unique=self.unique+1
	for i=1,#followers do
		local id=followers[i]
		if id then tinsert(missionEffects,id) end
	end
	for i=1,assigned do
		local id=select(i,...)
		if id then missionEffects['f' .. i]=id end
	end
	local index=format("%04d:%1d:%2d:%1d:%1d:%1d:%2d",
		1000-missionEffects.perc,
		#missionEffects,
		99-troopcost,
		missionEffects.improvements,
		missionEffects.champions,
		3-missionEffects.xpGainers,
		self.unique)
	if #missionEffects==0 then index="EMPTY" end
	missionEffects.key=index
	self.candidates[index]=setmetatable(missionEffects,CandidateMeta)
	self:Remove(followers)
	del(followers)
	return index
end

-- 
function partyManager:Match()
	local missionID=self.missionID
	if not missionID then print("Missing missionID",self) return false end
	local mission=addon:GetMissionData(missionID)
	if not mission then print("Missing mission ",missionID,self)return false end
	self.name=mission.name
	wipe(self.candidates)
	self.unique=0
	local _,baseXP,_,_,_,_,exhausting,enemies=G.GetMissionInfo(missionID)
	self.numFollowers=mission.numFollowers or G.GetMissionMaxFollowers(missionID)
	self.exhausting=exhausting
	self.elite=mission.elite
	self.baseXP=baseXP or 0
	self.rewardXP=(mission.class=="FollowerXP" and mission.value) or 0
	self.totalXP=self.baseXP+self.rewardXP
	local n
	local p=addon:GetFullPermutations()
	for i=1,#p do
		local tuple=p[i]
		local total,f1,f2,f3=strsplit(',',tuple)
		if tonumber(total) > self.numFollowers then break end
		self:Build(f1,f2,f3)
		n=i
	end
	self:Build()
	self:GenerateIndex()
	--[===[@debug@
	print("Match started for ", missionID, self.numFollowers,"followers",#addon:GetFullPermutations(),"builds",n,"indexed",#self.candidatesIndex,self.candidatesIndex)
	--@end-debug@]===]
	return true
end
function partyManager:GenerateIndex()
	wipe(self.candidatesIndex)
	for k,_ in pairs(self.candidates) do
		tinsert(self.candidatesIndex,k)
	end
	table.sort(self.candidatesIndex)
end
function module:OnInitialized()
	addon:AddLabel(L["Missions"],L["Configuration for mission party builder"])
	addon:AddBoolean("SAVETROOPS",false,L["Counter kill Troops"],L["Always counter kill troops (ignored if we can only use troops with just 1 durability left)"])
	addon:AddBoolean("NEVERKILLTROOPS",false,L["Never kill Troops"],L["Makes sure that no troops will be killed"])
	addon:AddBoolean("PREFERHIGH",false,L["Prefer high durability"],L["Uses tropps with the highest durability instead of the ones with the lowest"])
	addon:AddBoolean("NOTROOPS",false,L["Don't use troops"],L["Only use champions even if troops are available"])
	addon:AddBoolean("BONUS",true,L["Keep extra bonus"],L["Always counter no bonus loot threat"])
	addon:AddBoolean("SPARE",false,L["Keep cost low"],L["Always counter increased resource cost"])
	addon:AddBoolean("MAKEITQUICK",true,L["Keep time short"],L["Always counter increased time"])
	addon:AddBoolean("MAKEITVERYQUICK",false,L["Keep time VERY short"],L["Only accept missions with time improved"])
	addon:AddBoolean("MAXIMIZEXP",false,L["Maximize xp gain"],L["Favours leveling follower for xp missions"])
	addon:AddRange("MAXCHAMP",2,1,3,L["Max champions"],L["Use at most this many champions"],1)
	addon:AddRange("MINCHANCE",5,5,100,L["Absolute Minimum Chance"],L["Dont bother filling missions under this success chance. (Can speed up the whole selection)."],5)
	addon:AddRange("BONUSCHANCE",100,100,200,L["Bonus Chance"],L["If bonus chance is lower than this, then we try to cap at 100. Ignored for elite missions."],5)
	addon:AddRange("BASECHANCE",5,5,100,L["Base Chance"],L["When we cant achieve the requested bonus chance, we try to reach at least this one"],5)
	addon:AddBoolean("USEALLY",false,L["Use combat ally"],L["Combat ally is proposed for missions so you can consider unassigning him"])
	addon:AddBoolean("IGNOREBUSY",true,L["Ignore busy followers"],L["When no free followers are available shows empty follower"])
	addon:AddBoolean("IGNOREINACTIVE",true,L["Ignore inactive followers"],L["If not checked, inactive followers are used as last chance"])
	addon:RegisterForMenu("mission",
		"SAVETROOPS",
		"NEVERKILLTROOPS",
		'NOTROOPS',
		'PREFERHIGH',
		"BONUS",
		"SPARE",
		"MAKEITQUICK",
		"MAKEITVERYQUICK",
		"MAXIMIZEXP",
		'MAXCHAMP',
		'MINCHANCE',
		'BASECHANCE',
		'BONUSCHANCE',
		'USEALLY',
		'IGNOREBUSY',
		'IGNOREINACTIVE')
end
function module:remEvents()
	self:RegisterEvent("GARRISON_FOLLOWER_XP_CHANGED","Refresh")
	self:RegisterEvent("GARRISON_FOLLOWER_UPGRADED","Refresh")
	self:RegisterEvent("GARRISON_FOLLOWER_ADDED","Refresh")
	self:RegisterEvent("GARRISON_MISSION_STARTED","Refresh")
	self:RegisterEvent("GARRISON_MISSION_COMPLETE_RESPONSE","Refresh")
	self:RegisterEvent("FOLLOWER_LIST_UPDATE","Refresh")
end
function module:Refresh(event)
	self:ResetParties()
	addon.lastChange=GetTime()
	return addon:RefreshMissions()
end
function module:ResetParties()
	partiesPool:ReleaseAll()
	wipe(missionParties)
end
function addon:HoldEvents()
	return holdEvents()
end
function addon:ReleaseEvents()
	return releaseEvents()
end
function addon:GetSelectedParty(missionID,key)
	if addon:GetMissionData(missionID,"inProgress") then return emptyTable,"progress" end
	return self:GetMissionParties(missionID):GetSelectedParty(key)
end
function addon:ResetParties()
	return module:ResetParties()
end
--[===[@debug@
local cache={}
function addon:TestParty(missionID)
	local parties=self:GetMissionParties(missionID)
	wipe(cache)
	tinsert(cache,addon:GetMissionData(missionID,'name',missionID))
	local title=G.GetMissionName(missionID)
	self:Print("Debug for ", title)
	local choosen,choosenkey=parties:GetSelectedParty()
	self:Print(choosenkey)
	if ViragDevTool_AddData then
		ViragDevTool_AddData({_title=title,_key=choosenkey,data=parties.candidates},"Mission debug " .. title)
		parties:GetSelectedParty(true)
	end
end
--@end-debug@]===]

function addon:GetMissionParties(missionID)
	if not missionParties[missionID] then
		missionParties[missionID]=partiesPool:Acquire()
		missionParties[missionID].missionID=missionID
	end
	return missionParties[missionID]
end
function addon:GetAllMissionParties()
	return missionParties
end
function addon:RefillParties()
	local i=0
	collectgarbage("stop")
	holdEvents()
	addon:GetFullPermutations(true)
	partiesPool:ReleaseAll()
	wipe(missionParties)
	for n=1,#OHFMissions.availableMissions do
		self:GetMissionParties(OHFMissions.availableMissions[n].missionID):Match()
		i=n
	end
	releaseEvents()
	collectgarbage("restart")
	return i
end
function module:ProfileStats()
	addon:LoadProfileData(partyManager,"Matchmaker")
end
